/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the InfoMessageData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InfoMessageData{}

// InfoMessageData struct for InfoMessageData
type InfoMessageData struct {
	Type *string `json:"type,omitempty"`
	Payload *InfoMessagePayload `json:"payload,omitempty"`
}

// NewInfoMessageData instantiates a new InfoMessageData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInfoMessageData() *InfoMessageData {
	this := InfoMessageData{}
	return &this
}

// NewInfoMessageDataWithDefaults instantiates a new InfoMessageData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInfoMessageDataWithDefaults() *InfoMessageData {
	this := InfoMessageData{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *InfoMessageData) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InfoMessageData) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *InfoMessageData) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *InfoMessageData) SetType(v string) {
	o.Type = &v
}

// GetPayload returns the Payload field value if set, zero value otherwise.
func (o *InfoMessageData) GetPayload() InfoMessagePayload {
	if o == nil || IsNil(o.Payload) {
		var ret InfoMessagePayload
		return ret
	}
	return *o.Payload
}

// GetPayloadOk returns a tuple with the Payload field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InfoMessageData) GetPayloadOk() (*InfoMessagePayload, bool) {
	if o == nil || IsNil(o.Payload) {
		return nil, false
	}
	return o.Payload, true
}

// HasPayload returns a boolean if a field has been set.
func (o *InfoMessageData) HasPayload() bool {
	if o != nil && !IsNil(o.Payload) {
		return true
	}

	return false
}

// SetPayload gets a reference to the given InfoMessagePayload and assigns it to the Payload field.
func (o *InfoMessageData) SetPayload(v InfoMessagePayload) {
	o.Payload = &v
}

func (o InfoMessageData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InfoMessageData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Payload) {
		toSerialize["payload"] = o.Payload
	}
	return toSerialize, nil
}

type NullableInfoMessageData struct {
	value *InfoMessageData
	isSet bool
}

func (v NullableInfoMessageData) Get() *InfoMessageData {
	return v.value
}

func (v *NullableInfoMessageData) Set(val *InfoMessageData) {
	v.value = val
	v.isSet = true
}

func (v NullableInfoMessageData) IsSet() bool {
	return v.isSet
}

func (v *NullableInfoMessageData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInfoMessageData(val *InfoMessageData) *NullableInfoMessageData {
	return &NullableInfoMessageData{value: val, isSet: true}
}

func (v NullableInfoMessageData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInfoMessageData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


